"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MyDynamicSchemaProvider = void 0;
const ISchemaProvider_1 = require("../../formbuilder/models/schema/ISchemaProvider");
const PropertyOptionsFactory_1 = require("../../formbuilder/utils/PropertyOptionsFactory");
const MyDynamicFormItem_1 = require("./MyDynamicFormItem");
class MyDynamicSchemaProvider extends ISchemaProvider_1.SchemaProvider {
    constructor() {
        super(...arguments);
        this.key = "MyDynamicFormItem";
        this.itemType = () => MyDynamicFormItem_1.MyDynamicFormItem;
        this.getSchema = (dynamicKey) => __awaiter(this, void 0, void 0, function* () {
            const schema1 = {
                options: {
                    properties: {
                        id: PropertyOptionsFactory_1.propertyOptionsFactory.stringPropertyOption({ displayName: "This id", disable: () => true, description: "This is an explanation of what this property does.." }),
                        name: PropertyOptionsFactory_1.propertyOptionsFactory.stringPropertyOption({ displayName: "This name", description: "This is an explanation of what this property does.." }),
                        key: PropertyOptionsFactory_1.propertyOptionsFactory.stringPropertyOption({ displayName: "This key", disable: () => false, description: "This is an explanation of what this property does..", onChanged: (item) => { return { refreshDynamicSchema: item.key == "render2" }; } })
                    }
                }
            };
            const schema2 = {
                options: {
                    properties: {
                        // id: propertyOptionsFactory.stringPropertyOption({ displayName: "This id 2", disable: () => true, description: "This is an explanation of what this property does.." }),
                        name: PropertyOptionsFactory_1.propertyOptionsFactory.stringPropertyOption({ displayName: "This name 2", description: "This is an explanation of what this property does.." }),
                        key: PropertyOptionsFactory_1.propertyOptionsFactory.stringPropertyOption({ displayName: "This key 2", disable: () => false, description: "This is an explanation of what this property does..", onChanged: (item) => { return { refreshDynamicSchema: item.key == "render1" }; } })
                    }
                }
            };
            // defaults to the first schema
            if (dynamicKey == undefined)
                return schema1;
            return new Promise((resolve, reject) => {
                // fake api call
                setTimeout(() => {
                    console.log("dynamicKey", dynamicKey);
                    if (dynamicKey == "render1") {
                        resolve(schema1);
                    }
                    else if (dynamicKey == "render2") {
                        resolve(schema2);
                    }
                    else if (dynamicKey == undefined) {
                        resolve(schema1);
                    }
                    else {
                        reject();
                    }
                }, 500);
            });
        });
    }
}
exports.MyDynamicSchemaProvider = MyDynamicSchemaProvider;
//# sourceMappingURL=MyDynamicSchemaProvider.js.map