"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MyFormItemChildSchemaProvider = void 0;
const ISchemaProvider_1 = require("../../formbuilder/models/schema/ISchemaProvider");
const MyFormItemChild_1 = require("./MyFormItemChild");
const PropertyOptionsFactory_1 = require("../../formbuilder/utils/PropertyOptionsFactory");
const PropertyGroupOptionsFactory_1 = require("../../formbuilder/utils/PropertyGroupOptionsFactory");
const AnotherFormItem_1 = require("./AnotherFormItem");
const ValidationEventType_1 = require("../../formbuilder/models/validation/ValidationEventType");
const ValidationMark_1 = require("../../formbuilder/models/validation/ValidationMark");
const IFormBuilderListConfig_1 = require("../../formbuilder/components/config/IFormBuilderListConfig");
const react_1 = __importDefault(require("react"));
class MyFormItemChildSchemaProvider extends ISchemaProvider_1.SchemaProvider {
    constructor() {
        super(...arguments);
        this.key = "MyFormItemChild";
        this.itemType = () => MyFormItemChild_1.MyFormItemChild;
        this.getSchema = () => __awaiter(this, void 0, void 0, function* () {
            const schema = {
                options: {
                    groups: {
                        groupOne: PropertyGroupOptionsFactory_1.PropertyGroupOptionsFactory.GroupOptions({ displayName: "Group 1" }),
                        groupTwo: PropertyGroupOptionsFactory_1.PropertyGroupOptionsFactory.GroupOptions({ displayName: "Group 2", groupProps: { collapsed: true } })
                    },
                    validation: {
                        validationRules: {
                            name: { id: "mustbeesben", validationMark: ValidationMark_1.ValidationMark.Required, validationRule: (item) => item.name === "Esben", validationMessage: "Your name must be 'Esben'", validateOn: ValidationEventType_1.ValidationEventType.Blur | ValidationEventType_1.ValidationEventType.Manual },
                            age: { id: "lessthanforthy", validationMark: ValidationMark_1.ValidationMark.Required, validationRule: (item) => { var _a; return ((_a = item.age) !== null && _a !== void 0 ? _a : 0) < 40; }, validationMessage: "You must be less than 40 years old", validateOn: ValidationEventType_1.ValidationEventType.Blur | ValidationEventType_1.ValidationEventType.Manual },
                            child: { id: "nest", validationRule: () => true, validateOn: ValidationEventType_1.ValidationEventType.Blur | ValidationEventType_1.ValidationEventType.Manual, validationMessage: "", fromType: AnotherFormItem_1.AnotherFormItem },
                        }
                    },
                    properties: {
                        name: PropertyOptionsFactory_1.propertyOptionsFactory.stringPropertyOption({ displayName: "This name", group: "groupOne", config: { resizable: true }, description: "This is an explanation of what this property does.." }),
                        age: PropertyOptionsFactory_1.propertyOptionsFactory.numberPropertyOption({ displayName: "This age", group: "groupTwo", hideLabel: true, config: { allowNegativeNumbers: true } }),
                        childs: PropertyOptionsFactory_1.propertyOptionsFactory.formItemPropertyOption({
                            displayName: "Another 'FormItem' as a child array",
                            config: { itemType: AnotherFormItem_1.AnotherFormItem },
                            listItemOptions: { customValueRender: (item) => { var _a, _b; return react_1.default.createElement(react_1.default.Fragment, null, (_b = (_a = item.childs) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0); } },
                            listProps: {
                                config: {
                                    itemIdentifier: (item) => item.idid
                                },
                                editorConfig: { title: (item) => `Edit: ${item === null || item === void 0 ? void 0 : item.name}`, type: IFormBuilderListConfig_1.FormBuilderListEditorType.Dialog },
                                searchConfig: { searchableFields: ["name"], searchEnabled: true, searchPlaceHolder: "Filter child items by name.." }
                            }
                        }),
                    }
                }
            };
            return schema;
        });
    }
}
exports.MyFormItemChildSchemaProvider = MyFormItemChildSchemaProvider;
//# sourceMappingURL=MyFormItemSchemaProvider.js.map